// MetafileExplorerDoc.cpp : implementation of the CMetafileExplorerDoc class
//

#include "stdafx.h"
//#include "MetafileExplorer.h"

#include "MetafileExplorerDoc.h"
#include "EMFmsg.h"
#include "UpdateControls.h"
#include "QueryTree.h"
#include "IMGmsg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMetafileExplorerDoc

IMPLEMENT_DYNCREATE(CMetafileExplorerDoc, CDocument)

BEGIN_MESSAGE_MAP(CMetafileExplorerDoc, CDocument)
END_MESSAGE_MAP()


// CMetafileExplorerDoc construction/destruction

CMetafileExplorerDoc::CMetafileExplorerDoc()
   {
    meta = NULL;
    mode = DoDrawAll;
   }

CMetafileExplorerDoc::~CMetafileExplorerDoc()
   {
   }

/****************************************************************************
*                     CMetafileExplorerDoc::OnNewDocument
* Result: BOOL
*       
* Effect: 
*       Does nothing; this is MDI
****************************************************************************/

BOOL CMetafileExplorerDoc::OnNewDocument()
{
        if (!CDocument::OnNewDocument())
                return FALSE;

        // TODO: add reinitialization code here
        // (SDI documents will reuse this document)

        return TRUE;
}

// CMetafileExplorerDoc serialization

/****************************************************************************
*                       CMetafileExplorerDoc::Serialize
* Inputs:
*       CArchive & ar:
* Result: void
*       
* Effect: 
*       Does nothing; never called, unused
****************************************************************************/

void CMetafileExplorerDoc::Serialize(CArchive& ar)
   {
    if (ar.IsStoring())
       {
        // TODO: add storing code here
       }
    else
       {
        // TODO: add loading code here
       }
   }



// CMetafileExplorerDoc diagnostics
#ifdef _DEBUG
void CMetafileExplorerDoc::AssertValid() const
{
        CDocument::AssertValid();
}

void CMetafileExplorerDoc::Dump(CDumpContext& dc) const
{
        CDocument::Dump(dc);
}
#endif //_DEBUG


// CMetafileExplorerDoc commands

/****************************************************************************
*                       CMetafileExplorerDoc::metaEnum
* Inputs:
*       HDC: unused, NULL
*       HANDLETABLE *: ignored
*       CONST ENHMETARECORD * rec: Metarecord
*       int: count of objects in HANDLETABLE, ignored
*       LPARAM (LPARAM)(CMetafileExplorerDoc *)
* Result: int
*       zero to stop enumeration
*       nonzero to continue enumeration
* Effect: 
*       Loads the views with the raw metarecords
****************************************************************************/

/* static */ int CALLBACK CMetafileExplorerDoc::metaEnum(HDC, HANDLETABLE *, CONST ENHMETARECORD * rec, int, LPARAM p)
    {
     CMetafileExplorerDoc * doc = (CMetafileExplorerDoc *)p;
     doc->UpdateAllViews(NULL, EMF_RECORD, (CObject *)rec);
     return 1; // any nonzero value to continue enumeration
    } // CMetafileExplorerDoc::metaEnum

/****************************************************************************
*                    CMetafileExplorerDoc::ProcessMetafile
* Result: void
*       
* Effect: 
*       Processes the metafile
****************************************************************************/

void CMetafileExplorerDoc::ProcessMetafile(LPCTSTR filename)
    {
     UpdateAllViews(NULL, EMF_FILE, (CObject *)filename);

     CRect r;
     ::EnumEnhMetaFile(NULL, meta, metaEnum, this, &r);

     UpdateAllViews(NULL, UPD_UPDATECONTROLS, NULL);
    } // CMetafileExplorerDoc::ProcessMetafile

/****************************************************************************
*                    CMetafileExplorerDoc::OnOpenDocument
* Inputs:
*       LPCTSTR filename: File name
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Opens the document by creating a CMetaFile to hold it
****************************************************************************/

BOOL CMetafileExplorerDoc::OnOpenDocument(LPCTSTR filename)
    {
     meta = ::GetEnhMetaFile(filename);
     if(meta == NULL)
        return FALSE;

     ProcessMetafile(filename);
     return TRUE;
    } // CMetafileExplorerDoc::OnOpenDocument

/****************************************************************************
*                    CMetafileExplorerDoc::OnCloseDocument
* Result: void
*       
* Effect: 
*       Closes the metafile
****************************************************************************/

void CMetafileExplorerDoc::OnCloseDocument()
    {
     if(meta != NULL)
        ::DeleteEnhMetaFile(meta);
     meta = NULL;
     CDocument::OnCloseDocument();
    } // CMetafileExplorerDoc::OnCloseDocument

/****************************************************************************
*                        CMetafileExplorerDoc::DrawAll
* Result: void
*       
* Effect: 
*       Draws all
****************************************************************************/

void CMetafileExplorerDoc::DrawAll()
    {
     mode = DoDrawAll;
     updateControls();
     Invalidate();
    } // CMetafileExplorerDoc::DrawAll

/****************************************************************************
*                    CMetafileExplorerDoc::DrawSingleStep
* Result: void
*       
* Effect: 
*       Sets single-step drawing mode
****************************************************************************/

void CMetafileExplorerDoc::DrawSingleStep()
    {
     mode = DoDrawSingleStep;
     updateControls();
     Invalidate();
    } // CMetafileExplorerDoc::DrawSingleStep

/****************************************************************************
*                    CMetafileExplorerDoc::DrawToSelection
* Result: void
*       
* Effect: 
*       Sets up to draw to selection
****************************************************************************/

void CMetafileExplorerDoc::DrawToSelection()
    {
     mode = DoDrawToSelection;
     updateControls();
     Invalidate();
    } // CMetafileExplorerDoc::DrawToSelection

/****************************************************************************
*                       CMetafileExplorerDoc::QueryShow
* Inputs:
*       CONST ENHMETARECORD * record:
* Result: BOOL
*       TRUE if we can show this element
*       FALSE to not show it
****************************************************************************/

BOOL CMetafileExplorerDoc::QueryShow(CONST ENHMETARECORD * record)
    {
     if(mode == DoDrawAll)
        return TRUE;
     if(mode == DoDrawNone)
        return FALSE;

     QueryShowInfo query(record);

     UpdateAllViews(NULL, QRY_SHOWREQUEST, (CObject *)&query);
     return query.show;
    } // CMetafileExplorerDoc::QueryShow

/****************************************************************************
*                    CMetafileExplorerDoc::SendViewMessage
* Inputs:
*       UINT msg: Message to broadcast
*       LPVOID p: Value to send
* Result: void
*       
* Effect: 
*       Sends message to all views via UpdateAllViews
****************************************************************************/

void CMetafileExplorerDoc::SendViewMessage(UINT msg, LPVOID p, CView * view)
    {
     UpdateAllViews(view, msg, (CObject *)p);
    } // CMetafileExplorerDoc::SendViewMessage

/****************************************************************************
*                      CMetafileExplorerDoc::Invalidate
* Result: void
*       
* Effect: 
*       Invalidates all image views
****************************************************************************/

void CMetafileExplorerDoc::Invalidate()
    {
     UpdateAllViews(NULL, IMG_INVALIDATE, NULL);
    } // CMetafileExplorerDoc::Invalidate

/****************************************************************************
*                    CMetafileExplorerDoc::updateControls
* Result: void
*       
* Effect: 
*       Updates all controls
****************************************************************************/

void CMetafileExplorerDoc::updateControls()
    {
     UpdateAllViews(NULL, UPD_UPDATECONTROLS, NULL);
    } // CMetafileExplorerDoc::updateControls

