// MetafileExplorerView.h : interface of the CMetafileExplorerView class
//


#pragma once
#include "MetafileExplorerDoc.h"

class CMetafileExplorerView : public CTreeView
{
protected: // create from serialization only
        CMetafileExplorerView();
        DECLARE_DYNCREATE(CMetafileExplorerView)

// Attributes
public:
        CMetafileExplorerDoc* GetDocument() const;

// Operations
public:

// Overrides
        public:
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
        virtual void OnInitialUpdate(); // called first time after construct

// Implementation
public:
        virtual ~CMetafileExplorerView();
#ifdef _DEBUG
        virtual void AssertValid() const;
        virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
        void DecodeRecord(HTREEITEM item, CONST ENHMETARECORD * rec);
        HTREEITEM GetMetaRecord(HTREEITEM item);
        BOOL IsDrawable(HTREEITEM item);
        void DownToDrawable(HTREEITEM item, WPARAM wParam);

        CImageList imagelist;
        
        DECLARE_MESSAGE_MAP()
        virtual void OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/);
protected:
    afx_msg LRESULT OnMoveUp(WPARAM, LPARAM);
    afx_msg LRESULT OnMoveDown(WPARAM, LPARAM);
    afx_msg LRESULT OnAddFileName(WPARAM, LPARAM);
    afx_msg LRESULT OnAddRecord(WPARAM, LPARAM);
    afx_msg LRESULT OnQueryShowRequest( WPARAM, LPARAM);
    afx_msg LRESULT OnQueryRect(WPARAM, LPARAM);
    afx_msg LRESULT OnQueryEnable(WPARAM, LPARAM);
    afx_msg LRESULT OnQueryName(WPARAM, LPARAM);
    
    afx_msg void OnTvnSelchanged(NMHDR *pNMHDR, LRESULT *pResult);
};

#ifndef _DEBUG  // debug version in MetafileExplorerView.cpp
inline CMetafileExplorerDoc* CMetafileExplorerView::GetDocument() const
   { return reinterpret_cast<CMetafileExplorerDoc*>(m_pDocument); }
#endif

