#include "stdafx.h"
#include "metaheader.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/****************************************************************************
*                               GetDescription
* Inputs:
*       ENHMETAHEADER * hdr: Header
* Result: CStringW
*       Description string
****************************************************************************/

CStringW GetDescription(ENHMETAHEADER * hdr)
    {
     CStringW desc;

     if(hdr->nDescription > 0)
        desc = CStringW((LPCWSTR) ((LPBYTE)hdr + hdr->offDescription));
     return desc;
    } // GetDescription

/****************************************************************************
*                                PixelsTo01mm
* Inputs:
*       CRect & r: Rectangle to conver
* Result: void
*       
* Effect: 
*       Converts coordinates in r from pixels to 0.01mm units
****************************************************************************/

void PixelsTo01mm(CRect & r)
    {
     HDC dc = ::GetDC(NULL);
     ::SetMapMode(dc, MM_HIMETRIC); // 0.01mm per logical point

     // Modify so the y-axis increases downwards
     ::SetViewportExtEx(dc, 1, -1, NULL);
     ::SetWindowExtEx(dc, 1, 1, NULL);

     // Now convert it
     ::DPtoLP(dc, (POINT*)&r.left, 2);

     ::ReleaseDC(NULL, dc);
    } // PixelsTo01mm
